/////////////////////////////////////////////////
// LOGGING
/////////////////////////////////////////////////
const logger = require("../public/js/app/logger");

/////////////////////////////////////////////////
// APPELS DES MODULES
/////////////////////////////////////////////////
const moment = require('moment');
const ejs = require('ejs');
const nodemailer = require('nodemailer');
const path = require("path");
const fs = require("fs");
const mysql = require('mysql2');
const mysql_promise = require('mysql2/promise');
var md = require('markdown-it')({
  html:         true,        // Enable HTML tags in source
  xhtmlOut:     false,        // Use '/' to close single tags (<br />).
                              // This is only for full CommonMark compatibility.
  breaks:       true,        // Convert '\n' in paragraphs into <br>
  langPrefix:   'language-',  // CSS language prefix for fenced blocks. Can be
                              // useful for external highlighters.
  linkify:      false,        // Autoconvert URL-like text to links

  // Enable some language-neutral replacement + quotes beautification
  typographer:  true,

  // Double + single quotes replacement pairs, when typoglsrapher enabled,
  // and smartquotes on. Could be either a String or an Array.
  //
  // For example, you can use '«»„“' for Russian, '„“‚‘' for German,
  // and ['«\xA0', '\xA0»', '‹\xA0', '\xA0›'] for French (including nbsp).
  quotes: '“”‘’',

  // Highlighter function. Should return escaped HTML,
  // or '' if the source string is not changed and should be escaped externaly.
  // If result starts with <pre... internal wrapper is skipped.
  highlight: function (/*str, lang*/) { return ''; }
});

const {
  substringpage
} = require("../modules/substringpage.js");

// MODULES
const strapi_get = require("./../modules/strapi_get");

////////////////////////////////////////////////////
// FILE NAME
////////////////////////////////////////////////////
const filename = path.parse(__filename).base;

/////////////////////////////////////////////////
// AFFICHER PAGE ACCUEIL
/////////////////////////////////////////////////
const affiche_page_accueil = async function (req, res) {
  logger.info("======================================", { label: filename });
  logger.info("======== FUNCTION affiche_page_accueil ==========", { label: filename });
  logger.info("======================================", { label: filename });

  moment.locale('fr');
  let now = moment().format("YYYY-MM-DD");
  console.log("now = ", now);
  let date_fr = moment().format("DD/MM/YYYY");
  res.locals.date = date_fr;

  /////////////////////////////////////////////////
  // URL : domaine
  res.locals.domain = process.env.DOMAIN;
  res.locals.domain_strapi = process.env.DOMAIN_STRAPI;


  // Head metadata
  res.locals.SEO_Titre = "IPCI FE";
  res.locals.SEO_Description = "Née à Paris de la prise de conscience par les archetiers d’art de la fragilité de l’accès à la ressource en Pernambouc (Pau Brasilia Echinata), cette association, créée en l’an 2000, travaille en partenariat avec des ONG et les autorités brésiliennes à la replantation, la conservation, l’étude scientifique et à la traçabilité des stocks de bois existants. Actuellement entité la plus importante des IPCI en nombre d’adhérents, elle compte une soixantaine de membres, tous archetiers d’art. L’IPCI France-Europe est un interlocuteur essentiel lors des COP et des grands rdv CITES. En collaboration avec l’IPCI-France-Europe, il y a IPCI-Usa, IPCI-Allemagne et IPCI-Canada.";
  res.locals.SEO_keywords = "archet pernambouc";
  


  /////////////////////////////////////////////////
  // AFFICHAGE DE LA PAGE
  
  // FILS D'ARIANE
  console.log("req.url = ",req.url);
  let result = await substringpage(req.url);
  console.log("result in controller = ",result);
  res.locals.page = result;

  res.render('page_templates/accueil');

}

/////////////////////////////////////////////////
// AFFICHER PAGE PERNAMBOUC
/////////////////////////////////////////////////
const affiche_page_pernambouc = async function (req, res) {
  logger.info("======================================", { label: filename });
  logger.info("======== FUNCTION affiche_page_pernambouc ==========", { label: filename });
  logger.info("======================================", { label: filename });

  moment.locale('fr');
  let now = moment().format("YYYY-MM-DD");
  console.log("now = ", now);
  let date_fr = moment().format("DD/MM/YYYY");
  res.locals.date = date_fr;

  /////////////////////////////////////////////////
  // URL : domaine
  res.locals.domain = process.env.DOMAIN;
  res.locals.domain_strapi = process.env.DOMAIN_STRAPI;


  // Head metadata
  res.locals.SEO_Titre = "IPCI FE";
  res.locals.SEO_Description = "Née à Paris de la prise de conscience par les archetiers d’art de la fragilité de l’accès à la ressource en Pernambouc (Pau Brasilia Echinata), cette association, créée en l’an 2000, travaille en partenariat avec des ONG et les autorités brésiliennes à la replantation, la conservation, l’étude scientifique et à la traçabilité des stocks de bois existants. Actuellement entité la plus importante des IPCI en nombre d’adhérents, elle compte une soixantaine de membres, tous archetiers d’art. L’IPCI France-Europe est un interlocuteur essentiel lors des COP et des grands rdv CITES. En collaboration avec l’IPCI-France-Europe, il y a IPCI-Usa, IPCI-Allemagne et IPCI-Canada.";
  res.locals.SEO_keywords = "archet pernambouc";
  


  /////////////////////////////////////////////////
  // AFFICHAGE DE LA PAGE
  
  // FILS D'ARIANE
  console.log("req.url = ",req.url);
  let result = await substringpage(req.url);
  console.log("result in controller = ",result);
  res.locals.page = result;

  res.render('page_templates/pernambouc');

}

/////////////////////////////////////////////////
// AFFICHER PAGE INITIATIVES
/////////////////////////////////////////////////
const affiche_page_initiatives = async function (req, res) {
  logger.info("======================================", { label: filename });
  logger.info("======== FUNCTION affiche_page_initiatives ==========", { label: filename });
  logger.info("======================================", { label: filename });

  moment.locale('fr');
  let now = moment().format("YYYY-MM-DD");
  console.log("now = ", now);
  let date_fr = moment().format("DD/MM/YYYY");
  res.locals.date = date_fr;

  /////////////////////////////////////////////////
  // URL : domaine
  res.locals.domain = process.env.DOMAIN;
  res.locals.domain_strapi = process.env.DOMAIN_STRAPI;


  // Head metadata
  res.locals.SEO_Titre = "IPCI FE";
  res.locals.SEO_Description = "Née à Paris de la prise de conscience par les archetiers d’art de la fragilité de l’accès à la ressource en Pernambouc (Pau Brasilia Echinata), cette association, créée en l’an 2000, travaille en partenariat avec des ONG et les autorités brésiliennes à la replantation, la conservation, l’étude scientifique et à la traçabilité des stocks de bois existants. Actuellement entité la plus importante des IPCI en nombre d’adhérents, elle compte une soixantaine de membres, tous archetiers d’art. L’IPCI France-Europe est un interlocuteur essentiel lors des COP et des grands rdv CITES. En collaboration avec l’IPCI-France-Europe, il y a IPCI-Usa, IPCI-Allemagne et IPCI-Canada.";
  res.locals.SEO_keywords = "archet pernambouc";
  


  /////////////////////////////////////////////////
  // AFFICHAGE DE LA PAGE
  
  // FILS D'ARIANE
  console.log("req.url = ",req.url);
  let result = await substringpage(req.url);
  console.log("result in controller = ",result);
  res.locals.page = result;

  res.render('page_templates/initiatives');

}

/////////////////////////////////////////////////
// AFFICHER PAGE COOPERATIONS
/////////////////////////////////////////////////
const affiche_page_cooperations = async function (req, res) {
  logger.info("======================================", { label: filename });
  logger.info("======== FUNCTION affiche_page_cooperation ==========", { label: filename });
  logger.info("======================================", { label: filename });

  moment.locale('fr');
  let now = moment().format("YYYY-MM-DD");
  console.log("now = ", now);
  let date_fr = moment().format("DD/MM/YYYY");
  res.locals.date = date_fr;

  /////////////////////////////////////////////////
  // URL : domaine
  res.locals.domain = process.env.DOMAIN;
  res.locals.domain_strapi = process.env.DOMAIN_STRAPI;


  // Head metadata
  res.locals.SEO_Titre = "IPCI FE";
  res.locals.SEO_Description = "Née à Paris de la prise de conscience par les archetiers d’art de la fragilité de l’accès à la ressource en Pernambouc (Pau Brasilia Echinata), cette association, créée en l’an 2000, travaille en partenariat avec des ONG et les autorités brésiliennes à la replantation, la conservation, l’étude scientifique et à la traçabilité des stocks de bois existants. Actuellement entité la plus importante des IPCI en nombre d’adhérents, elle compte une soixantaine de membres, tous archetiers d’art. L’IPCI France-Europe est un interlocuteur essentiel lors des COP et des grands rdv CITES. En collaboration avec l’IPCI-France-Europe, il y a IPCI-Usa, IPCI-Allemagne et IPCI-Canada.";
  res.locals.SEO_keywords = "archet pernambouc";
  


  /////////////////////////////////////////////////
  // AFFICHAGE DE LA PAGE
  
  // FILS D'ARIANE
  console.log("req.url = ",req.url);
  let result = await substringpage(req.url);
  console.log("result in controller = ",result);
  res.locals.page = result;

  res.render('page_templates/cooperations');

}

/////////////////////////////////////////////////
// AFFICHER PAGE ACTUALITÉS
/////////////////////////////////////////////////
const affiche_page_actualites = async function (req, res) {
  logger.info("======================================", { label: filename });
  logger.info("======== FUNCTION affiche_page_actualites ==========", { label: filename });
  logger.info("======================================", { label: filename });

  moment.locale('fr');
  let now = moment().format("YYYY-MM-DD");
  console.log("now = ", now);
  let date_fr = moment().format("DD/MM/YYYY");
  res.locals.date = date_fr;

  /////////////////////////////////////////////////
  // URL : domaine
  res.locals.domain = process.env.DOMAIN;
  res.locals.domain_strapi = process.env.DOMAIN_STRAPI;


  // Head metadata
  res.locals.SEO_Titre = "IPCI FE";
  res.locals.SEO_Description = "Née à Paris de la prise de conscience par les archetiers d’art de la fragilité de l’accès à la ressource en Pernambouc (Pau Brasilia Echinata), cette association, créée en l’an 2000, travaille en partenariat avec des ONG et les autorités brésiliennes à la replantation, la conservation, l’étude scientifique et à la traçabilité des stocks de bois existants. Actuellement entité la plus importante des IPCI en nombre d’adhérents, elle compte une soixantaine de membres, tous archetiers d’art. L’IPCI France-Europe est un interlocuteur essentiel lors des COP et des grands rdv CITES. En collaboration avec l’IPCI-France-Europe, il y a IPCI-Usa, IPCI-Allemagne et IPCI-Canada.";
  res.locals.SEO_keywords = "archet pernambouc";
  


  /////////////////////////////////////////////////
  // AFFICHAGE DE LA PAGE
  
  // FILS D'ARIANE
  console.log("req.url = ",req.url);
  let result = await substringpage(req.url);
  console.log("result in controller = ",result);
  res.locals.page = result;

  res.render('page_templates/actualites');

}

/////////////////////////////////////////////////
// AFFICHER PAGE PARTICIPER
/////////////////////////////////////////////////
const affiche_page_participer = async function (req, res) {
  logger.info("======================================", { label: filename });
  logger.info("======== FUNCTION affiche_page_participer ==========", { label: filename });
  logger.info("======================================", { label: filename });

  moment.locale('fr');
  let now = moment().format("YYYY-MM-DD");
  console.log("now = ", now);
  let date_fr = moment().format("DD/MM/YYYY");
  res.locals.date = date_fr;

  /////////////////////////////////////////////////
  // URL : domaine
  res.locals.domain = process.env.DOMAIN;
  res.locals.domain_strapi = process.env.DOMAIN_STRAPI;


  // Head metadata
  res.locals.SEO_Titre = "IPCI FE";
  res.locals.SEO_Description = "Née à Paris de la prise de conscience par les archetiers d’art de la fragilité de l’accès à la ressource en Pernambouc (Pau Brasilia Echinata), cette association, créée en l’an 2000, travaille en partenariat avec des ONG et les autorités brésiliennes à la replantation, la conservation, l’étude scientifique et à la traçabilité des stocks de bois existants. Actuellement entité la plus importante des IPCI en nombre d’adhérents, elle compte une soixantaine de membres, tous archetiers d’art. L’IPCI France-Europe est un interlocuteur essentiel lors des COP et des grands rdv CITES. En collaboration avec l’IPCI-France-Europe, il y a IPCI-Usa, IPCI-Allemagne et IPCI-Canada.";
  res.locals.SEO_keywords = "archet pernambouc";
  


  /////////////////////////////////////////////////
  // AFFICHAGE DE LA PAGE
  
  // FILS D'ARIANE
  console.log("req.url = ",req.url);
  let result = await substringpage(req.url);
  console.log("result in controller = ",result);
  res.locals.page = result;

  res.render('page_templates/participer');

}

/////////////////////////////////////////////////
// AFFICHER PAGE QUI SOMMES NOUS ?
/////////////////////////////////////////////////
const affiche_page_ipcife = async function (req, res) {
  logger.info("======================================", { label: filename });
  logger.info("======== FUNCTION affiche_page_ipcife ==========", { label: filename });
  logger.info("======================================", { label: filename });

  moment.locale('fr');
  let now = moment().format("YYYY-MM-DD");
  console.log("now = ", now);
  let date_fr = moment().format("DD/MM/YYYY");
  res.locals.date = date_fr;

  /////////////////////////////////////////////////
  // URL : domaine
  res.locals.domain = process.env.DOMAIN;
  res.locals.domain_strapi = process.env.DOMAIN_STRAPI;


  // Head metadata
  res.locals.SEO_Titre = "IPCI FE";
  res.locals.SEO_Description = "Née à Paris de la prise de conscience par les archetiers d’art de la fragilité de l’accès à la ressource en Pernambouc (Pau Brasilia Echinata), cette association, créée en l’an 2000, travaille en partenariat avec des ONG et les autorités brésiliennes à la replantation, la conservation, l’étude scientifique et à la traçabilité des stocks de bois existants. Actuellement entité la plus importante des IPCI en nombre d’adhérents, elle compte une soixantaine de membres, tous archetiers d’art. L’IPCI France-Europe est un interlocuteur essentiel lors des COP et des grands rdv CITES. En collaboration avec l’IPCI-France-Europe, il y a IPCI-Usa, IPCI-Allemagne et IPCI-Canada.";
  res.locals.SEO_keywords = "archet pernambouc";
  


  /////////////////////////////////////////////////
  // AFFICHAGE DE LA PAGE
  
  // FILS D'ARIANE
  console.log("req.url = ",req.url);
  let result = await substringpage(req.url);
  console.log("result in controller = ",result);
  res.locals.page = result;

  res.render('page_templates/ipcife');

}

/////////////////////////////////////////////////
// AFFICHER PAGE RESSOURCES
/////////////////////////////////////////////////
const affiche_page_ressources = async function (req, res) {
  logger.info("======================================", { label: filename });
  logger.info("======== FUNCTION affiche_page_ressources ==========", { label: filename });
  logger.info("======================================", { label: filename });

  moment.locale('fr');
  let now = moment().format("YYYY-MM-DD");
  console.log("now = ", now);
  let date_fr = moment().format("DD/MM/YYYY");
  res.locals.date = date_fr;

  /////////////////////////////////////////////////
  // URL : domaine
  res.locals.domain = process.env.DOMAIN;
  res.locals.domain_strapi = process.env.DOMAIN_STRAPI;


  // Head metadata
  res.locals.SEO_Titre = "IPCI FE";
  res.locals.SEO_Description = "Née à Paris de la prise de conscience par les archetiers d’art de la fragilité de l’accès à la ressource en Pernambouc (Pau Brasilia Echinata), cette association, créée en l’an 2000, travaille en partenariat avec des ONG et les autorités brésiliennes à la replantation, la conservation, l’étude scientifique et à la traçabilité des stocks de bois existants. Actuellement entité la plus importante des IPCI en nombre d’adhérents, elle compte une soixantaine de membres, tous archetiers d’art. L’IPCI France-Europe est un interlocuteur essentiel lors des COP et des grands rdv CITES. En collaboration avec l’IPCI-France-Europe, il y a IPCI-Usa, IPCI-Allemagne et IPCI-Canada.";
  res.locals.SEO_keywords = "archet pernambouc";
  


  /////////////////////////////////////////////////
  // AFFICHAGE DE LA PAGE
  
  // FILS D'ARIANE
  console.log("req.url = ",req.url);
  let result = await substringpage(req.url);
  console.log("result in controller = ",result);
  res.locals.page = result;

  res.render('page_templates/ressources');

}

/////////////////////////////////////////////////
// EXPORT DE MODULE POUR QU'IL SOIT LU DANS LES AUTRES FICHIERS JS
/////////////////////////////////////////////////
module.exports = {
  affiche_page_accueil,
  affiche_page_pernambouc,
  affiche_page_initiatives,
  affiche_page_cooperations,
  affiche_page_actualites,
  affiche_page_participer,
  affiche_page_ipcife,
  affiche_page_ressources
}

